## GtkStatusbar GtkStatusbar — Report messages of minor importance to the user |

## Functions

GtkWidget * | gtk_statusbar_new ()
guint | gtk_statusbar_get_context_id ()
guint | gtk_statusbar_push ()
void | gtk_statusbar_pop ()
void | gtk_statusbar_remove ()
void | gtk_statusbar_remove_all ()
GtkWidget * | gtk_statusbar_get_message_area ()

## Style Properties

GtkShadowType | shadow-type | Read

## Signals

void | text-popped | Run Last
void | text-pushed | Run Last

## Types and Values

struct | GtkStatusbar

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkContainer
                    ╰── GtkBox
                        ╰── GtkStatusbar

## Implemented Interfaces

GtkStatusbar implements AtkImplementorIface, GtkBuildable and GtkOrientable.

## Includes

    #include <gtk/gtk.h>

## Description

A GtkStatusbar is usually placed along the bottom of an application's main GtkWindow. It may provide a regular commentary of the application's status (as is usually the case in a web browser, for example), or may be used to simply output a message when the status changes, (when an upload is complete in an FTP client, for example).

Status bars in GTK+ maintain a stack of messages. The message at the top of the each bar’s stack is the one that will currently be displayed.

Any messages added to a statusbar’s stack must specify a context id that is used to uniquely identify the source of a message. This context id can be generated by `gtk_statusbar_get_context_id()`, given a message and the statusbar that it will be added to. Note that messages are stored in a stack, and when choosing which message to display, the stack structure is adhered to, regardless of the context identifier of a message.

One could say that a statusbar maintains one stack of messages for display purposes, but allows multiple message producers to maintain sub-stacks of the messages they produced (via context ids).

Status bars are created using `gtk_statusbar_new()`.

Messages are added to the bar’s stack with `gtk_statusbar_push()`.

The message at the top of the stack can be removed using `gtk_statusbar_pop()`. A message can be removed from anywhere in the stack if its message id was recorded at the time it was added. This is done using `gtk_statusbar_remove()`.

### CSS node

GtkStatusbar has a single CSS node with name statusbar.

## Functions

### gtk_statusbar_new ()

    GtkWidget *
    gtk_statusbar_new (void);

Creates a new GtkStatusbar ready for messages.

#### Returns

the new GtkStatusbar

### gtk_statusbar_get_context_id ()

    guint
    gtk_statusbar_get_context_id (GtkStatusbar *statusbar,
                                  const gchar *context_description);

Returns a new context identifier, given a description of the actual context. Note that the description is not shown in the UI.

#### Parameters

statusbar | a GtkStatusbar |
context_description | textual description of what context the new message is being used in |

#### Returns

an integer id

### gtk_statusbar_push ()

    guint
    gtk_statusbar_push (GtkStatusbar *statusbar,
                        guint context_id,
                        const gchar *text);

Pushes a new message onto a statusbar’s stack.

#### Parameters

statusbar | a GtkStatusbar |
context_id | the message’s context id, as returned by `gtk_statusbar_get_context_id()` |
text | the message to add to the statusbar |

#### Returns

a message id that can be used with `gtk_statusbar_remove()`.

### gtk_statusbar_pop ()

    void
    gtk_statusbar_pop (GtkStatusbar *statusbar,
                       guint context_id);

Removes the first message in the GtkStatusbar’s stack with the given context id.

Note that this may not change the displayed message, if the message at the top of the stack has a different context id.

#### Parameters

statusbar | a GtkStatusbar |
context_id | a context identifier |

### gtk_statusbar_remove ()

    void
    gtk_statusbar_remove (GtkStatusbar *statusbar,
                          guint context_id,
                          guint message_id);

Forces the removal of a message from a statusbar’s stack. The exact `context_id` and `message_id` must be specified.

#### Parameters

statusbar | a GtkStatusbar |
context_id | a context identifier |
message_id | a message identifier, as returned by `gtk_statusbar_push()` |

### gtk_statusbar_remove_all ()

    void
    gtk_statusbar_remove_all (GtkStatusbar *statusbar,
                              guint context_id);

Forces the removal of all messages from a statusbar's stack with the exact `context_id` .

#### Parameters

statusbar | a GtkStatusbar |
context_id | a context identifier |

Since: 2.22

### gtk_statusbar_get_message_area ()

    GtkWidget *
    gtk_statusbar_get_message_area (GtkStatusbar *statusbar);

Retrieves the box containing the label widget.

#### Parameters

statusbar | a GtkStatusbar |

#### Returns

a GtkBox.

[type Gtk.Box][transfer none]

Since: 2.20

## Types and Values

### struct GtkStatusbar

    struct GtkStatusbar;

## Style Property Details

### The `“shadow-type”` style property

      “shadow-type”              GtkShadowType

The style of the bevel around the statusbar text.

`GtkStatusbar:shadow-type` has been deprecated since version 3.20 and should not be used in newly-written code.

Use CSS properties to determine the appearance, the value of this style property is ignored.

Owner: GtkStatusbar

Flags: Read

Default value: GTK_SHADOW_IN

## Signal Details

### The `“text-popped”` signal

    void
    user_function (GtkStatusbar *statusbar,
                   guint         context_id,
                   char         *text,
                   gpointer      user_data)

Is emitted whenever a new message is popped off a statusbar's stack.

#### Parameters

statusbar | the object which received the signal |
context_id | the context id of the relevant message/statusbar |
text | the message that was just popped |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“text-pushed”` signal

    void
    user_function (GtkStatusbar *statusbar,
                   guint         context_id,
                   char         *text,
                   gpointer      user_data)

Is emitted whenever a new message gets pushed onto a statusbar's stack.

#### Parameters

statusbar | the object which received the signal |
context_id | the context id of the relevant message/statusbar |
text | the message that was pushed |
user_data | user data set when the signal handler was connected. |

Flags: Run Last